#ifndef ADETHERNET_H_INCLUDED
#define ADETHERNET_H_INCLUDED

#ifdef UNIQUE_NAMES
	#define NAME(x) Generic_Driver_##x
#else
	#define NAME(x) x
#endif

#ifdef __cplusplus
extern "C"
{
#endif

extern int    openConnect (char	IP[16], char passwd[10], int link, int Port, unsigned Timeout);
extern void   closeConnect (void);
extern int    reConnect (char *IP, char passwd[10], int link, int Port, unsigned Timeout);
extern long   NAME (Get_Par) (long Index);
extern void   NAME (Set_Par) (long Index, long Value);
extern void   NAME (Set_FPar) (long Index, float Value);
extern float  NAME (Get_FPar) (long Index);
extern void   NAME (Get_Par_All) (long *pData);
extern void   NAME (Get_Par_Block) (long *pData, long StartIndex, long Count);
extern void   NAME (Get_FPar_All) (float *pData);
extern void   NAME (Get_FPar_Block) (float *pData, long StartIndex, long Count);
extern short  NAME (GetDataType) (short datanr);
extern long   NAME (Workload) (void);
extern long   NAME (Fifo_Full) (long FifoNo);
extern long   NAME (Fifo_Empty) (long FifoNo);
extern void   NAME (Fifo_Clear) (long FifoNo);
extern void   NAME (Get_Fifo) (long FifoNo,short typ, void *Data,long Count);
extern void   NAME (Set_Fifo) (long FifoNo,short typ, void *Data,  long Count);
extern void   NAME (Get_Data) (long DataNo,void *Data, short type,  long StarIndex, long Count);
extern void   NAME (Set_Data) (long DataNo,void *Data, short type,  long StarIndex, long Count);
//extern short  CreateData(short datanr, short type, long groesse, short ort, short art);
extern void   NAME (Boot) (char *filename); //24.11.03 von ADboot--> Boot; K.Sp.
extern void   NAME (Load_Process) (char *filename); // 24.11.03 von ADBload --> Load_Process; K.Sp.
extern void   NAME (Start_Process) (long ProcessNo); //25.11.03 von ADbasicStart -->Start_Process;
extern void   NAME (Stop_Process) (long ProcessNo);//25.11.03 von ADbasicStop-->Stop_Process
extern void   NAME (Clear_Process) (long ProcessNo);
extern long   NAME (Free_Mem) (long Mem_Spec);
extern void   NAME (Set_Language) (long language);
extern long   NAME (Process_Status) (long ProcessNo);
extern long   NAME (Get_GlobalDelay) (long ProcessNo);
extern void   NAME (Set_GlobalDelay) (long ProcessNo, long GlobalDelay);
extern long   NAME (Test_Version) ();
extern long   NAME (Processor_Type) ();

extern void   NAME (GetData_Long) (long DataNo, long *Data, long Startindex, long Count);
extern void   NAME (GetData_Float) (long DataNo, float *Data, long Startindex, long Count);
extern void   NAME (SetData_Long) (long DataNo, long *Data, long Startindex, long Count);
extern void   NAME (SetData_Float) (long DataNo, float *Data, long Startindex, long Count);
extern void   NAME (SetFifo_Long) (long FifoNo, long *Data, long Count);
extern void   NAME (SetFifo_Float) (long FifoNo, float *Data, long Count);
extern void   NAME (GetFifo_Long) (long FifoNo, long *Data, long Count);
extern void   NAME (GetFifo_Float) (long FifoNo, float *Data, long Count);
extern long   NAME (String_Length) (long DataNo);
extern void   NAME (SetData_String) (long DataNo, char *Data);
extern long   NAME (GetData_String) (long DataNo, char *Data, long MaxCount);

extern int    NAME (Clear_Data) (long DataNo);
extern long   NAME (Data_Length) (long DataNo);

extern long   NAME (Get_Last_Error) ();
extern long   NAME (Get_Last_Error_Text) (long errorcode,char *text,long textlaenge);

#ifdef USE_FOR_LIBADWIN
extern void   NAME (Get_Data) (long DataNo, void *Data, short typ, long StartIndex, long Count);
extern void   NAME (Set_Data) (long DataNo, void *Data, short typ, long StartIndex, long Count);
extern void   NAME (Get_Fifo) (long FifoNo, short typ, void *Data, long Count);
extern void   NAME (Set_Fifo) (long FifoNo, short typ, void *Data, long Count);
#endif

#ifdef __cplusplus
}
#endif

#endif // !defined ADETHERNET_H_INCLUDED
