
#ifndef __DSP_H__
#define __DSP_H__

#include <linux/adwin.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int DSP_Test_Version(adwin_dev_t *dev, int fd);

extern long DSP_Boot(adwin_dev_t *dev, int fd, char *filename, long iboardsize);

extern int DSP_Load_Process(adwin_dev_t *dev, int fd, char *filename);
extern int DSP_Start_Process(adwin_dev_t *dev, int fd, int processID);
extern int DSP_Stop_Process(adwin_dev_t *dev, int fd, int processID);
extern int DSP_Clear_Process(adwin_dev_t *dev, int fd, int processID);
extern int DSP_Process_Status(adwin_dev_t *dev, int fd, int processID);

extern int DSP_Free_Mem(adwin_dev_t *dev, int fd, int Mem_Spec, int *dest);
extern int DSP_Workload(adwin_dev_t *dev, int fd);

extern int DSP_Set_Par(adwin_dev_t *dev, int fd, int Parameternr, int32_t value);
extern int DSP_Set_FPar(adwin_dev_t *dev, int fd, int Parameternr, float value);

extern int DSP_Get_Par(adwin_dev_t *dev, int fd, int Parameternr, int *value);
extern int DSP_Get_FPar(adwin_dev_t *dev, int fd, int Parameternr, float *value);

// "long *dest" wegen generischem Treiber, damit keine unntigen Warnungen erzeugt werden
extern int DSP_Get_Par_All(adwin_dev_t *dev, int fd, int first, int cnt, long *dest);
extern int DSP_Get_FPar_All(adwin_dev_t *dev, int fd, int first, int cnt, float *dest);

extern int DSP_GetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *dest);
extern int DSP_SetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *src);

extern int DSP_Data_Length(adwin_dev_t *dev, int fd, long DataNo);

extern int DSP_Fifo_Clear(adwin_dev_t *dev, int fd, int FifoNo);
extern int DSP_Fifo_Empty(adwin_dev_t *dev, int fd, int FifoNo, int *dest);
extern int DSP_Fifo_Full(adwin_dev_t *dev, int fd, int FifoNo, int *dest);

extern int DSP_SetFifo(adwin_dev_t *dev, int fd, int FifoNo, long count, void *src);
extern int DSP_GetFifo(adwin_dev_t *dev, int fd, int FifoNo, long count, void *dest);


// ***************************** unsupported *****************************
extern int DSP_Get_Memory_dsp(adwin_dev_t *dev, int fd, int base_addr, int anzahl, int32_t *dest);

extern int DSP_Clear_Data(adwin_dev_t *dev, int fd, int Datanr);
extern int DSP_GetDataType(adwin_dev_t *dev, int fd, int datanr);




#ifdef __cplusplus
}
#endif


#endif /* __DSP_H__ */
