****************************************
*	 Prozenummer = 1
*	 Delay = 1953
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
' file : FFT_phase_demo.BAS			
' 990715 JK  created
' 020322 JK  IMPORT FFT.LI9
' 040130 JK  updated for T10 processor
' for all ADwin-systems with T9 or T10 processor
'--------------------------------------------------------------------------

' This program generates internally two frequencies with 30 Hz.
' The second frequency has a phase shift of PI / 2 .
' Both waveforms are sampled synchronously.
' After calling the functions FFT(), FFT_mag(), FFT_scale() and 
' FFT_phase() seperately for each waveform, we get a spectrum with the 
' following characteristics :
'			DATA_6[4]   = 1                    (30 Hz)
'			DATA_6[all other elements]   = 0
'			DATA_7[4]   = -0.018410            (phase = ca. 0)
'
'			DATA_26[4]  = 1                    (30 Hz)
'			DATA_26[all other elements]  = 0
'			DATA_27[4]  = 1.552389             (phase = ca. PI / 2)
'
' Remark : The phase of all other elements is undefined (means : must 
'                                                               not be 0).

#IF PROZESSOR = T10 THEN
IMPORT FFT.LIA
#ELSE
IMPORT FFT.LI9
#ENDIF

#DEFINE PI 		3.141592654 

DIM  DATA_1[1024],  DATA_6[512],  DATA_7[512] AS FLOAT AT DM_LOCAL
DIM DATA_21[1024], DATA_26[512], DATA_27[512] AS FLOAT AT DM_LOCAL
DIM  DATA_2[1024], DATA_3[4096], DATA_4[4096] AS FLOAT AT DM_LOCAL
DIM help_1[4096], help_2[4096]               AS FLOAT AT DM_LOCAL
DIM run, number                              AS LONG
DIM sim_freq1, sim_freq2, sim_phase2, T_total, sample_freq AS FLOAT   

LOWINIT:
  number = 1024   ' number of points for FFT (must be a power of 2)
  T_total = 0.1   ' [s]  total sampling time  
  sample_freq = number / T_total ' [Hz] ( = 10240 Hz)
  '	25 ns is the unit of ADSP system timer for a high priority process
  GLOBALDELAY = 1000000000 * T_total / number / 25

  sim_freq1 = 30      ' [Hz]     internal frequency generator 1
  sim_freq2 = 30      ' [Hz]     internal frequency generator 2
  sim_phase2 = PI / 2 ' [Radians]
  run = 1
EVENT:
  DATA_1[run]  = cos(2*PI * sim_freq1 * T_total * run/number ) 
  DATA_21[run] = cos(2*PI * sim_freq2 * T_total * run/number - sim_phase2) 
  DATA_2[run] = 0     '  clear the array with imaginary rate of data

  IF (run = number) THEN	END
  run = run + 1
	
FINISH:
  FFT(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number)
  FFT_mag(DATA_3, DATA_4, DATA_6, number / 2) ' magnitude into DATA_6
  FFT_scale(DATA_6, DATA_6, number / 2) ' scaled magnitude into DATA_6
  FFT_phase(DATA_3, DATA_4, DATA_7, number / 2) ' phase into DATA_7

  FFT(DATA_21, DATA_2, DATA_3, DATA_4, help_1, help_2, number)
  FFT_mag(DATA_3, DATA_4, DATA_26, number / 2) ' magnitude2 into DATA_26
  FFT_scale(DATA_26, DATA_26, number / 2) ' scaled magnitude2 into DATA_26
  FFT_phase(DATA_3, DATA_4, DATA_27, number / 2) ' phase2 into DATA_27
